--- cdda2wav/mycdrom.h.orig
+++ cdda2wav/mycdrom.h
@@ -4,6 +4,12 @@
 #else
 # if defined HAVE_SYS_CDIO_H
 #  include <sys/cdio.h>
+#  if (defined(__FreeBSD__) && __FreeBSD__ >= 2) || defined(__DragonFly__)
+#   include <osreldate.h>
+#   if __FreeBSD_version >= 400014 || defined(__DragonFly__)
+#    include <sys/cdrio.h>
+#   endif
+#  endif
 
 #  if (defined (__sun) && defined (SVR4))
 #   if 0
@@ -52,8 +58,8 @@
 
 #   endif /* if 0 */
 #  else /* not Sun SVR4 */
-#   if defined __FreeBSD__ || defined __NetBSD__ || defined __OpenBSD__
-#    if !defined CDIOCREADAUDIO
+#   if defined __FreeBSD__  || defined __DragonFly__ || defined __NetBSD__ || defined __OpenBSD__
+#    if (!defined(__FreeBSD__) && !defined(CDIOCREADAUDIO)) || __FreeBSD_version < 228000
 #     undef HAVE_IOCTL_INTERFACE
 #    else
 
